package com.emato.cus.config;

import org.springframework.boot.web.servlet.FilterRegistrationBean;
import org.springframework.context.annotation.Bean;
import org.springframework.context.annotation.Configuration;
import org.springframework.web.filter.CharacterEncodingFilter;
import org.springframework.web.servlet.resource.DefaultServletHttpRequestHandler;

@Configuration
public class WebMvcConfiguration {

    /**
     * 编码过滤器
     * @return
     */
    @Bean
    public FilterRegistrationBean myCharacterEncodingFilter() {
        CharacterEncodingFilter filter = new CharacterEncodingFilter();
        filter.setEncoding("UTF-8");
        filter.setForceEncoding(true);

        FilterRegistrationBean filterBean = new FilterRegistrationBean();
        filterBean.setFilter(filter);
        filterBean.addUrlPatterns("/*");
        return filterBean;
    }

    /**
     * 对进入DispatcherServlet的URL进行筛查
     * 如果发现是静态资源的请求，就将该请求转由Web应用服务器默认的Servlet处理
     * 如果不是静态资源的请求，才由DispatcherServlet继续处理
     * @return
     */
    @Bean
    public DefaultServletHttpRequestHandler defaultServletHttpRequestHandler() {
        return new DefaultServletHttpRequestHandler();
    }
}